/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import { Contract, Signer, utils } from "ethers";
import type { Provider } from "@ethersproject/providers";
import type {
  ICommunityLogic,
  ICommunityLogicInterface,
} from "../../../../../contracts/core/logics/interfaces/ICommunityLogic";

const _abi = [
  {
    inputs: [
      {
        components: [
          {
            internalType: "string",
            name: "handle",
            type: "string",
          },
          {
            internalType: "address",
            name: "condition",
            type: "address",
          },
          {
            internalType: "bytes",
            name: "conditionData",
            type: "bytes",
          },
          {
            internalType: "address",
            name: "joinModule",
            type: "address",
          },
          {
            internalType: "bytes",
            name: "joinModuleInitData",
            type: "bytes",
          },
        ],
        internalType: "struct OspDataTypes.CreateCommunityData",
        name: "vars",
        type: "tuple",
      },
    ],
    name: "createCommunity",
    outputs: [
      {
        internalType: "uint256",
        name: "",
        type: "uint256",
      },
    ],
    stateMutability: "nonpayable",
    type: "function",
  },
  {
    inputs: [
      {
        components: [
          {
            internalType: "address",
            name: "to",
            type: "address",
          },
          {
            internalType: "string",
            name: "handle",
            type: "string",
          },
          {
            internalType: "address",
            name: "condition",
            type: "address",
          },
          {
            internalType: "bytes",
            name: "conditionData",
            type: "bytes",
          },
          {
            internalType: "address",
            name: "joinModule",
            type: "address",
          },
          {
            internalType: "bytes",
            name: "joinModuleInitData",
            type: "bytes",
          },
          {
            components: [
              {
                internalType: "uint8",
                name: "v",
                type: "uint8",
              },
              {
                internalType: "bytes32",
                name: "r",
                type: "bytes32",
              },
              {
                internalType: "bytes32",
                name: "s",
                type: "bytes32",
              },
              {
                internalType: "uint256",
                name: "deadline",
                type: "uint256",
              },
            ],
            internalType: "struct OspDataTypes.EIP712Signature",
            name: "sig",
            type: "tuple",
          },
        ],
        internalType: "struct OspDataTypes.CreateCommunityWithSigData",
        name: "vars",
        type: "tuple",
      },
    ],
    name: "createCommunityWithSig",
    outputs: [
      {
        internalType: "uint256",
        name: "",
        type: "uint256",
      },
    ],
    stateMutability: "nonpayable",
    type: "function",
  },
  {
    inputs: [
      {
        internalType: "uint256",
        name: "communityId",
        type: "uint256",
      },
      {
        internalType: "address",
        name: "from",
        type: "address",
      },
      {
        internalType: "address",
        name: "to",
        type: "address",
      },
    ],
    name: "emitCommunityNFTTransferEvent",
    outputs: [],
    stateMutability: "nonpayable",
    type: "function",
  },
  {
    inputs: [
      {
        internalType: "uint256",
        name: "communityId",
        type: "uint256",
      },
    ],
    name: "getCommunity",
    outputs: [
      {
        components: [
          {
            internalType: "string",
            name: "handle",
            type: "string",
          },
          {
            internalType: "address",
            name: "joinModule",
            type: "address",
          },
          {
            internalType: "address",
            name: "joinNFT",
            type: "address",
          },
        ],
        internalType: "struct OspDataTypes.CommunityStruct",
        name: "",
        type: "tuple",
      },
    ],
    stateMutability: "view",
    type: "function",
  },
  {
    inputs: [
      {
        internalType: "string",
        name: "handle",
        type: "string",
      },
    ],
    name: "getCommunityIdByHandle",
    outputs: [
      {
        internalType: "uint256",
        name: "",
        type: "uint256",
      },
    ],
    stateMutability: "view",
    type: "function",
  },
  {
    inputs: [
      {
        internalType: "uint256",
        name: "communityId",
        type: "uint256",
      },
    ],
    name: "getCommunityTokenURI",
    outputs: [
      {
        internalType: "string",
        name: "",
        type: "string",
      },
    ],
    stateMutability: "view",
    type: "function",
  },
  {
    inputs: [
      {
        internalType: "uint256",
        name: "communityId",
        type: "uint256",
      },
    ],
    name: "getJoinModule",
    outputs: [
      {
        internalType: "address",
        name: "",
        type: "address",
      },
    ],
    stateMutability: "view",
    type: "function",
  },
  {
    inputs: [
      {
        internalType: "uint256",
        name: "communityId",
        type: "uint256",
      },
    ],
    name: "getJoinNFT",
    outputs: [
      {
        internalType: "address",
        name: "",
        type: "address",
      },
    ],
    stateMutability: "view",
    type: "function",
  },
  {
    inputs: [
      {
        internalType: "uint256",
        name: "communityId",
        type: "uint256",
      },
      {
        internalType: "address",
        name: "joinModule",
        type: "address",
      },
      {
        internalType: "bytes",
        name: "joinModuleInitData",
        type: "bytes",
      },
    ],
    name: "setJoinModule",
    outputs: [],
    stateMutability: "nonpayable",
    type: "function",
  },
  {
    inputs: [
      {
        components: [
          {
            internalType: "uint256",
            name: "communityId",
            type: "uint256",
          },
          {
            internalType: "address",
            name: "joinModule",
            type: "address",
          },
          {
            internalType: "bytes",
            name: "joinModuleInitData",
            type: "bytes",
          },
          {
            components: [
              {
                internalType: "uint8",
                name: "v",
                type: "uint8",
              },
              {
                internalType: "bytes32",
                name: "r",
                type: "bytes32",
              },
              {
                internalType: "bytes32",
                name: "s",
                type: "bytes32",
              },
              {
                internalType: "uint256",
                name: "deadline",
                type: "uint256",
              },
            ],
            internalType: "struct OspDataTypes.EIP712Signature",
            name: "sig",
            type: "tuple",
          },
        ],
        internalType: "struct OspDataTypes.SetJoinModuleWithSigData",
        name: "vars",
        type: "tuple",
      },
    ],
    name: "setJoinModuleWithSig",
    outputs: [],
    stateMutability: "nonpayable",
    type: "function",
  },
] as const;

export class ICommunityLogic__factory {
  static readonly abi = _abi;
  static createInterface(): ICommunityLogicInterface {
    return new utils.Interface(_abi) as ICommunityLogicInterface;
  }
  static connect(
    address: string,
    signerOrProvider: Signer | Provider
  ): ICommunityLogic {
    return new Contract(address, _abi, signerOrProvider) as ICommunityLogic;
  }
}
